unit BunDisp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, stream, shiki, bundispcal, Math;

type
  TBunDisp = class(TImage)
  private
    { Private 錾 }
    txt:string;
    bc:TBunDispCalc;
    backGround:TImage;
    charWidth:Integer;
    procedure setText(s:string);
    procedure setCanvas(image:TImage);
    procedure copyCanvas;
    function getText:string;
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    scrollBar: TScrollBar;
    procedure refresh;
    procedure scrollImage(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
    constructor Create(AOwner: TComponent; hScrollBar:TScrollBar);
    destructor Destroy; override;
    property text:string read getText write setText;
  published
    { Published 錾 }
  end;


implementation
{---------------------
  
 ---------------------}
constructor TBunDisp.Create(AOwner: TComponent; hScrollBar:TScrollBar);
begin
   inherited Create(AOwner);
   width:=2000;      {ȂƂ̌㉡ύXłȂ}
   height := 500;    {Ȃ}
   Canvas.Font.Assign((AOwner as TForm).font);
   backGround := TImage.Create(Self);
   backGround.width := 2000;
   backGround.height := 500;
   setCanvas(backGround);
   scrollBar := hScrollBar;
   scrollBar.kind := sbHorizontal;
   scrollBar.Position := 0;
   scrollBar.Min := 0;
   scrollBar.SmallChange := 5;
   scrollBar.LargeChange := 50;
   scrollBar.visible := true;
   bc := TBunDispCalc.Create(Self);
   charWidth := Canvas.textHeight('0');
   Height := charWidth * 3 + 6;
end;

{---------------------
   sl͕̉KvȂ͂
 ---------------------}
destructor TBunDisp.Destroy;
begin
   bc.free;
   backGround.free;
   inherited Destroy;
end;

{--------------------------
  textvpeB̓ǂݏo
 --------------------------}
function TBunDisp.getText() :string;
begin
    Result := txt;
end;


{-----------------------------
  textvpeB̕ύX̏
 -----------------------------}
procedure TBunDisp.setText(s:string);
var xpos:LongInt;
begin
    txt := s;
    background.width := max(width, background.width);
    bc.write(background.Canvas,0,0,background.width,height,txt);
    xpos := background.Canvas.PenPos.x;
    if xpos >= background.width then begin
      xpos := min(high(Integer), xpos);
      backGround.free;
      backGround := TImage.Create(Self);
      background.width := xpos +2;
      backGround.height := 500;
      setCanvas(backGround);
      bc.write(background.Canvas,0,0,background.width,height,txt);
      xpos := background.Canvas.PenPos.x;
    end;
    scrollBar.Max := max(0,xpos - width);
    scrollBar.position := 0;
    if scrollBar.min = scrollBar.max then begin
      scrollBar.visible := false;
    end else begin
      scrollBar.visible := true;
    end;
    copyCanvas;
end;

{---------------------
  ď
 ---------------------}
procedure TBunDisp.refresh;
begin
   setCanvas(backGround);
   bc.free;
   bc := TBunDispCalc.Create(Self);
   Height := Canvas.textHeight('0') * 3 + 6;
   setText(txt);
end;

{----------------------------------------------
  obNOEhtHAOEhɃRs[
 ----------------------------------------------}
procedure TBunDisp.copyCanvas;
var dist:TRect;
    src:TRect;
begin
  dist.Top := 0;
  dist.Left := 0;
  dist.Right := width;
  dist.Bottom := height;
  src.Top := 0;
  src.Bottom := height;
  src.left := scrollBar.position;
  src.right := src.left + width;
  Canvas.copyRect(dist, backGround.canvas, src);
end;
{-------------------------
  LpX̑Zbg
 -------------------------}
procedure TBunDisp.setCanvas(image:Timage);
begin
   image.Canvas.Font.Assign(Canvas.font);
   image.Canvas.Brush.Style := bsSolid;
   image.Canvas.Brush.Color := clWhite;
   image.Canvas.pen.color := image.Canvas.Font.Color;
   image.Canvas.pen.width := image.Canvas.Font.size div 8;
   if image.Canvas.pen.width < 1 then begin
     image.Canvas.pen.width := 1;
   end;
end;
{-------------------------
  XN[
 -------------------------}
procedure TBunDisp.scrollImage(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  copyCanvas;
end;

end.
